/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#define CSSED_WINDOW(n) (Tcssed_window*) n

// colors used in the output window
#define ERROR_COLOR_STRING "red"
#define WARNING_COLOR_STRING "navy"

typedef struct _cssed_window_dynamic_menu_items {
	GtkWidget *menu_item_line_numbers;
	GtkWidget *menu_item_endings;
	GtkWidget *menu_item_white_spaces;
	GtkWidget *menu_item_lines_wrapped;
	GtkWidget *menu_item_eol_mode_cr;
	GtkWidget *menu_item_eol_mode_lf;
	GtkWidget *menu_item_eol_mode_crlf;
	GtkWidget *menu_item_autocompletion;
	GtkWidget *menu_item_folding;
} Tcssed_dyn_menus;

// configuration 
typedef struct _csssed_config {
	// window
	gint window_x;
	gint window_y;
	gint window_width;
	gint window_height;
	gint notebook_height;
	gint sidebar_width;
	gint treeview_height;
	// document
	gboolean linenumbers;
	gboolean autocompletion;
	gboolean lineendings;
	gboolean whitespaces;
	gboolean folding;
	gboolean lineswraped;
	gchar* font;
	gint font_size;
	// opened docs
	GList* opened_docs;
	// highlighting
	gint DEFAULT_fore_color;
	gint DEFAULT_back_color;
	gboolean DEFAULT_bold;
	gint TAG_fore_color;
	gint TAG_back_color;
	gboolean TAG_bold;
	gint PSEUDOCLASS_fore_color;
	gint PSEUDOCLASS_back_color;
	gboolean PSEUDOCLASS_bold;
	gint UNKNOWN_PSEUDOCLASS_fore_color;
	gint UNKNOWN_PSEUDOCLASS_back_color;	
	gboolean UNKNOWN_PSEUDOCLASS_bold;
	gint OPERATOR_fore_color;
	gint OPERATOR_back_color;
	gboolean OPERATOR_bold;
	gint IDENTIFIER_fore_color;	
	gint IDENTIFIER_back_color;	
	gboolean IDENTIFIER_bold;
	gint UNKNOWN_IDENTIFIER_fore_color;
	gint UNKNOWN_IDENTIFIER_back_color;
	gboolean UNKNOWN_IDENTIFIER_bold;
	gint VALUE_fore_color;
	gint VALUE_back_color;	
	gboolean VALUE_bold;
	gint COMMENT_fore_color;
	gint COMMENT_back_color;
	gboolean COMMENT_bold;
	gint IMPORTANT_fore_color;
	gint IMPORTANT_back_color;
	gboolean IMPORTANT_bold;
	gint DIRECTIVE_fore_color;
	gint DIRECTIVE_back_color;
	gboolean DIRECTIVE_bold;
	gint DOUBLESTRING_fore_color;
	gint DOUBLESTRING_back_color;	
	gboolean DOUBLESTRING_bold;
	gint SINGLESTRING_fore_color;
	gint SINGLESTRING_back_color;
	gboolean SINGLESTRING_bold;
	gint CLASS_fore_color;
	gint CLASS_back_color;	
	gboolean CLASS_bold;
	gint ID_fore_color;
	gint ID_back_color;	
	gboolean ID_bold;
	gint VALID_VALUE_fore_color;
	gint VALID_VALUE_back_color;
	gboolean VALID_VALUE_bold;
	gint FUNCTION_fore_color;
	gint FUNCTION_back_color;
	gboolean FUNCTION_bold;
	gint NUMBER_fore_color;
	gint NUMBER_back_color;
	gboolean NUMBER_bold;
	gint UNIT_fore_color;
	gint UNIT_back_color;
	gboolean UNIT_bold;
	gint COLOR_fore_color;
	gint COLOR_back_color;	
	gboolean COLOR_bold;
	gint HEXACOLOR_fore_color;
	gint HEXACOLOR_back_color;	
	gboolean HEXACOLOR_bold;
	gint ATTR_MATCH_fore_color;
	gint ATTR_MATCH_back_color;	
	gboolean ATTR_MATCH_bold;
	gint LANGUAGE_fore_color;
	gint LANGUAGE_back_color;	
	gboolean LANGUAGE_bold;
} Tcssed_cfg ;

typedef struct _cssed_window {
	GtkWidget* notebook_docs;				// the documents notebook
	GtkWidget* notebook_utils;  			// the output and scratch pad notebook
	GtkWidget* tree_view_css_properties;	// the tree with CSS def from XML parsing
	GtkWidget* tree_view_css_current;		// The current selector properties
	GtkListStore* output_store;				// the program output will be stored here
	GtkListStore* css_store;				// When a selector is scaned, it's props & values will be stored here
	Tcssed_dyn_menus* dynamic_menus;		// the dinamic view menu, must change in a document basis
	GList* document_list;					// the document list
	gchar* keywords_list;					// a space separated string will all def keywords from XML parsing
	Tcssed_cfg* config;						// configuration data
} Tcssed_window;

typedef struct _cssed_config_parser_data {
	Tcssed_window* window;
	gint depth;
	gint state;		
}  Tcssed_cp_data;
